# rpmio/macro.c File Reference

More...

`#include "system.h"`
`#include <stdarg.h>`
`#include <rpmio_internal.h>`
`#include <rpmmessages.h>`
`#include <rpmerr.h>`
`#include <rpmmacro.h>`
`#include "debug.h"`

Go to the source code of this file.

## Data Structures

struct | MacroBuf_s
| Macro expansion state. More...

## Defines

#define | isblank(_c) ((_c) == ' ' || (_c) == '\t')
#define | iseol(_c) ((_c) == '\n' || (_c) == '\r')
#define | STREQ(_t, _f, _fn) ((_fn) == (sizeof(_t)-1) && !strncmp((_t), (_f), (_fn)))
#define | SAVECHAR(_mb, _c) { *(_mb)->t = (_c), (_mb)->t++, (_mb)->nb--; }
#define | MAX_MACRO_DEPTH 16
#define | MACRO_CHUNK_SIZE 16
#define | SKIPBLANK(_s, _c)
#define | SKIPNONBLANK(_s, _c)
#define | COPYNAME(_ne, _s, _c)
#define | COPYOPTS(_oe, _s, _c)
#define | COPYBODY(_be, _s, _c)

## Typedefs

typedef MacroBuf_s * | MacroBuf
| Macro expansion state.

## Functions

int | expandMacro (MacroBuf mb)
| The main macro recursion loop.
void * | _free (const void *p)
| Wrapper to free(3), hides const compilation noise, permit NULL, return NULL.
int | compareMacroName (const void *ap, const void *bp)
| Compare macro entries by name (qsort/bsearch).
void | expandMacroTable (MacroContext mc)
| Enlarge macro table.
void | sortMacroTable (MacroContext mc)
| Sort entries in macro table.
void | rpmDumpMacroTable (MacroContext mc, FILE *fp)
| Print macros to file stream.
MacroEntry * | findEntry (MacroContext mc, const char *name, size_t namelen)
| Find entry in macro table.
char * | rdcl (char *buf, size_t size, FD_t fd, int escapes)
| fgets(3) analogue that reads \ continuations.
const char * | matchchar (const char *p, char pl, char pr)
| Return text between pl and matching pr characters.
void | printMacro (MacroBuf mb, const char *s, const char *se)
| Pre-print macro expression to be expanded.
void | printExpansion (MacroBuf mb, const char *t, const char *te)
| Post-print expanded macro expression.
int | expandT (MacroBuf mb, const char *f, size_t flen)
| Save source and expand field into target.
int | expandU (MacroBuf mb, char *u, size_t ulen)
| Save source/target and expand macro in u.
int | doShellEscape (MacroBuf mb, const char *cmd, size_t clen)
| Expand output of shell command into target buffer.
const char * | doDefine (MacroBuf mb, const char *se, int level, int expandbody)
| Parse (and execute) new macro definition.
const char * | doUndefine (MacroContext mc, const char *se)
| Parse (and execute) macro undefinition.
void | pushMacro (MacroEntry *mep, const char *n, const char *o, const char *b, int level)
| Push new macro definition onto macro entry stack.
void | popMacro (MacroEntry *mep)
| Pop macro definition from macro entry stack.
void | freeArgs (MacroBuf mb)
| Free parsed arguments for parameterized macro.
const char * | grabArgs (MacroBuf mb, const MacroEntry me, const char *se, char lastc)
| Parse arguments (to next new line) for parameterized macro.
void | doOutput (MacroBuf mb, int waserror, const char *msg, size_t msglen)
| Perform macro message output.
void | doFoo (MacroBuf mb, int negate, const char *f, size_t fn, const char *g, size_t glen)
| Execute macro primitives.
int | expandMacros (void *spec, MacroContext mc, char *sbuf, size_t slen)
| Expand macro into buffer.
void | addMacro (MacroContext mc, const char *n, const char *o, const char *b, int level)
| Add macro to context.
void | delMacro (MacroContext mc, const char *n)
| Delete macro from context.
int | rpmDefineMacro (MacroContext mc, const char *macro, int level)
| Define macro in context.
void | rpmLoadMacros (MacroContext mc, int level)
| Load macros from specific context into global context.
void | rpmInitMacros (MacroContext mc, const char *macrofiles)
| Initialize global macro context from set of macrofile(s).
void | rpmFreeMacros (MacroContext mc)
| Destroy macro context.
int | isCompressed (const char *file, rpmCompressedMagic *compressed)
| Return type of compression used in file.
char * | rpmExpand (const char *arg,...)
| Return (malloc'ed) concatenated macro expansion(s).
int | rpmExpandNumeric (const char *arg)
| Return macro expansion as a numeric value.
char * | rpmCleanPath (char *path)
| Canonicalize file path.
const char * | rpmGetPath (const char *path,...)
| Return (malloc'ed) expanded, canonicalized, file path.
const char * | rpmGenPath (const char *urlroot, const char *urlmdir, const char *urlfile)
| Merge 3 args into path, any or all of which may be a url.

## Variables

int | _debug = 0
MacroContext_s | rpmGlobalMacroContext_s
MacroContext | rpmGlobalMacroContext = &rpmGlobalMacroContext_s
MacroContext_s | rpmCLIMacroContext_s
MacroContext | rpmCLIMacroContext = &rpmCLIMacroContext_s
int | max_macro_depth = 16
int | print_macro_trace = 0
int | print_expand_trace = 0

## Detailed Description

Definition in file macro.c.

## Define Documentation

#define COPYBODY | ( | _be,
|  | _s,
|  | _c |  | ) |

Value:

    {       while(((_c) = *(_s)) && !iseol(_c)) { \
                    if ((_c) == '\\') \
                            (_s)++; \
                    *(_be)++ = *(_s)++; \
            }                       \
            *(_be) = '\0';          \
        }

Definition at line 448 of file macro.c.

Referenced by doDefine().

#define COPYNAME | ( | _ne,
|  | _s,
|  | _c |  | ) |

Value:

    {       SKIPBLANK(_s,_c);       \
            while(((_c) = *(_s)) && (xisalnum(_c) || (_c) == '_')) \
                    *(_ne)++ = *(_s)++; \
            *(_ne) = '\0';          \
        }

Definition at line 435 of file macro.c.

Referenced by doDefine(), and doUndefine().

#define COPYOPTS | ( | _oe,
|  | _s,
|  | _c |  | ) |

Value:

    {       while(((_c) = *(_s)) && (_c) != ')') \
                    *(_oe)++ = *(_s)++; \
            *(_oe) = '\0';          \
        }

Definition at line 442 of file macro.c.

Referenced by doDefine().

#define isblank | ( | _c |  | ) | ((_c) == ' ' || (_c) == '\t')

| Definition at line 12 of file macro.c. Referenced by doDefine(), doFoo(), expandMacro(), and grabArgs().

#define iseol | ( | _c |  | ) | ((_c) == '\n' || (_c) == '\r')

| Definition at line 14 of file macro.c. Referenced by doDefine(), doShellEscape(), doUndefine(), expandMacro(), printExpansion(), printMacro(), and rdcl().

#define MACRO_CHUNK_SIZE 16

| Definition at line 104 of file macro.c. Referenced by expandMacroTable().

#define MAX_MACRO_DEPTH 16

| Definition at line 87 of file macro.c.

#define SAVECHAR | ( | _mb,
|  | _c |  | ) | { *(_mb)->t = (_c), (_mb)->t++, (_mb)->nb--; }

| Definition at line 83 of file macro.c. Referenced by doShellEscape(), and expandMacro().

#define SKIPBLANK | ( | _s,
|  | _c |  | ) |

Value:

    while (((_c) = *(_s)) && isblank(_c)) \
                    (_s)++;

Definition at line 427 of file macro.c.

Referenced by doDefine(), and rpmInitMacros().

#define SKIPNONBLANK | ( | _s,
|  | _c |  | ) |

Value:

    while (((_c) = *(_s)) && !(isblank(_c) || iseol(_c))) \
                    (_s)++;

Definition at line 431 of file macro.c.

#define STREQ | ( | _t,
|  | _f,
|  | _fn |  | ) | ((_fn) == (sizeof(_t)-1) && !strncmp((_t), (_f), (_fn)))

| Definition at line 16 of file macro.c. Referenced by doFoo(), and expandMacro().

## Typedef Documentation

typedef struct MacroBuf_s * MacroBuf

| Macro expansion state. Referenced by doDefine(), doFoo(), doOutput(), doShellEscape(), expandMacro(), expandMacros(), expandT(), expandU(), freeArgs(), grabArgs(), printExpansion(), printMacro(), and rpmDefineMacro().

## Function Documentation

void* _free | ( | const void * | p | ) | `[inline, static]`

Wrapper to free(3), hides const compilation noise, permit NULL, return NULL.

Parameters:

  p | memory to free

Return values:

  NULL | always

Definition at line 121 of file macro.c.

void addMacro | ( | MacroContext | mc,
|  | const char * | n,
|  | const char * | o,
|  | const char * | b,
|  | int | level
| ) |

Add macro to context.

Deprecated:
  Use rpmDefineMacro().

Parameters:

  mc | macro context (NULL uses global context).
  n | macro name
  o | macro paramaters
  b | macro body
  level | macro recursion level (0 is entry API)

Definition at line 1490 of file macro.c.

References expandMacroTable(), findEntry(), MacroContext_s::firstFree, MacroContext, MacroEntry, MacroContext_s::macrosAllocated, MacroContext_s::macroTable, pushMacro(), rpmGlobalMacroContext, and sortMacroTable().

Referenced by addSource(), buildForTarget(), doAddMacro(), doDefine(), doReadRC(), doScript(), doSetupMacro(), expandMacro(), grabArgs(), handlePreambleTag(), main(), makeGPGSignature(), makePGPSignature(), parseSpec(), rpmInstallLoadMacros(), rpmLoadMacros(), rpmRebuildTargetVars(), setDefaults(), setPathDefault(), setVarDefault(), verifyGPGSignature(), and verifyPGPSignature().

int compareMacroName | ( | const void * | ap,
|  | const void * | bp
| ) | `[static]`

Compare macro entries by name (qsort/bsearch).

Parameters:

  ap | 1st macro entry
  bp | 2nd macro entry

Returns:
  result of comparison

Definition at line 137 of file macro.c.

References MacroEntry, and MacroEntry_s::name.

Referenced by findEntry(), and sortMacroTable().

void delMacro | ( | MacroContext | mc,
|  | const char * | n
| ) |

Delete macro from context.

Parameters:

  mc | macro context (NULL uses global context).
  n | macro name

Definition at line 1516 of file macro.c.

References findEntry(), MacroContext, MacroEntry, popMacro(), rpmGlobalMacroContext, and sortMacroTable().

Referenced by doDelMacro(), doScript(), doUndefine(), handlePreambleTag(), makeGPGSignature(), makePGPSignature(), parseSpec(), rpmRebuildTargetVars(), verifyGPGSignature(), and verifyPGPSignature().

const char* doDefine | ( | MacroBuf | mb,
|  | const char * | se,
|  | int | level,
|  | int | expandbody
| ) | `[static]`

Parse (and execute) new macro definition.

Parameters:

  mb | macro expansion state
  se | macro definition to parse
  level | macro recursion level
  expandbody | should body be expanded?

Returns:
  address to continue parsing

Definition at line 600 of file macro.c.

References _, addMacro(), COPYBODY, COPYNAME, COPYOPTS, expandU(), isblank, iseol, MacroBuf, matchchar(), MacroBuf_s::mc, RPMERR_BADSPEC, rpmError, SKIPBLANK, and xisalpha().

Referenced by expandMacro(), and rpmDefineMacro().

void doFoo | ( | MacroBuf | mb,
|  | int | negate,
|  | const char * | f,
|  | size_t | fn,
|  | const char * | g,
|  | size_t | glen
| ) | `[static]`

Execute macro primitives.

Parameters:

  mb | macro expansion state
  negate | should logic be inverted?
  f | beginning of field f
  fn | length of field f
  g | beginning of field g
  gn | length of field g

Definition at line 1026 of file macro.c.

References COMPRESSED_OTHER, expandT(), expandU(), isblank, isCompressed(), MacroBuf, rpmCompressedMagic, rpmIsVerbose, STREQ, urlPath(), and xisdigit().

Referenced by expandMacro().

void doOutput | ( | MacroBuf | mb,
|  | int | waserror,
|  | const char * | msg,
|  | size_t | msglen
| ) | `[static]`

Perform macro message output.

Parameters:

  mb | macro expansion state
  waserror | use rpmError()?
  msg | message to ouput
  msglen | no. of bytes in message

Definition at line 999 of file macro.c.

References expandU(), MacroBuf, RPMERR_BADSPEC, and rpmError.

Referenced by expandMacro().

int doShellEscape | ( | MacroBuf | mb,
|  | const char * | cmd,
|  | size_t | clen
| ) | `[static]`

Expand output of shell command into target buffer.

Parameters:

  mb | macro expansion state
  cmd | shell command
  clen | no. bytes in shell command

Returns:
  result of expansion

Definition at line 560 of file macro.c.

References expandU(), iseol, MacroBuf, MacroBuf_s::nb, SAVECHAR, and MacroBuf_s::t.

Referenced by expandMacro().

const char* doUndefine | ( | MacroContext | mc,
|  | const char * | se
| ) | `[static]`

Parse (and execute) macro undefinition.

Parameters:

  mc | macro context
  se | macro name to undefine

Returns:
  address to continue parsing

Definition at line 696 of file macro.c.

References _, COPYNAME, delMacro(), iseol, MacroContext, RPMERR_BADSPEC, rpmError, and xisalpha().

Referenced by expandMacro().

int expandMacro | ( | MacroBuf | mb | ) | `[static]`

The main macro recursion loop.

Todo:
  Dynamically reallocate target buffer.

Parameters:

  mb | macro expansion state

Returns:
  0 on success, 1 on failure

Definition at line 1126 of file macro.c.

References _, addMacro(), MacroEntry_s::body, MacroBuf_s::depth, doDefine(), doFoo(), doOutput(), doShellEscape(), doUndefine(), MacroBuf_s::expand_trace, expandT(), findEntry(), freeArgs(), grabArgs(), isblank, iseol, MacroBuf_s::macro_trace, MacroBuf, MacroEntry, matchchar(), max_macro_depth, MacroBuf_s::mc, MacroEntry_s::name, MacroBuf_s::nb, MacroEntry_s::opts, print_expand_trace, print_macro_trace, printExpansion(), printMacro(), RMIL_GLOBAL, rpmDumpMacroTable(), RPMERR_BADSPEC, rpmError, MacroBuf_s::s, SAVECHAR, STREQ, MacroBuf_s::t, MacroEntry_s::used, and xisalnum().

Referenced by expandMacros(), expandT(), and expandU().

int expandMacros | ( | void * | spec,
|  | MacroContext | mc,
|  | char * | sbuf,
|  | size_t | slen
| ) |

Expand macro into buffer.

Deprecated:
  Use rpmExpand().

Todo:
  Eliminate from API.

Parameters:

  spec | cookie (unused)
  mc | macro context (NULL uses global context).

Return values:

  sbuf | input macro to expand, output expansion

Parameters:

  slen | size of buffer

Returns:
  0 on success

Definition at line 1451 of file macro.c.

References _, alloca(), expandMacro(), MacroBuf, MacroContext, print_expand_trace, print_macro_trace, RPMERR_BADSPEC, rpmError, and rpmGlobalMacroContext.

Referenced by addFileToTagAux(), copyNextLine(), processPackageFiles(), rpmExpand(), and rpmGetPath().

void expandMacroTable | ( | MacroContext | mc | ) | `[static]`

Enlarge macro table.

Parameters:

  mc | macro context

Definition at line 157 of file macro.c.

References MacroContext_s::firstFree, MACRO_CHUNK_SIZE, MacroContext, MacroEntry, MacroContext_s::macrosAllocated, MacroContext_s::macroTable, xmalloc(), and xrealloc().

Referenced by addMacro().

int expandT | ( | MacroBuf | mb,
|  | const char * | f,
|  | size_t | flen
| ) | `[static]`

Save source and expand field into target.

Parameters:

  mb | macro expansion state
  f | field
  flen | no. bytes in field

Returns:
  result of expansion

Definition at line 465 of file macro.c.

References alloca(), expandMacro(), MacroBuf, and MacroBuf_s::s.

Referenced by doFoo(), and expandMacro().

int expandU | ( | MacroBuf | mb,
|  | char * | u,
|  | size_t | ulen
| ) | `[static]`

Save source/target and expand macro in u.

Parameters:

  mb | macro expansion state
  u | input macro, output expansion
  ulen | no. bytes in u buffer

Returns:
  result of expansion

Definition at line 520 of file macro.c.

References alloca(), expandMacro(), MacroBuf, MacroBuf_s::nb, MacroBuf_s::s, and MacroBuf_s::t.

Referenced by doDefine(), doFoo(), doOutput(), doShellEscape(), and grabArgs().

MacroEntry* findEntry | ( | MacroContext | mc,
|  | const char * | name,
|  | size_t | namelen
| ) | `[static]`

Find entry in macro table.

Parameters:

  mc | macro context
  name | macro name
  namelen | no. of byes

Returns:
  address of slot in macro table with name (or NULL)

Definition at line 241 of file macro.c.

References compareMacroName(), MacroContext_s::firstFree, MacroContext, MacroEntry, MacroContext_s::macroTable, and rpmGlobalMacroContext.

Referenced by addMacro(), delMacro(), expandMacro(), headerFindI18NString(), headerGetRawEntry(), htGetEntry(), htHasEntry(), and intGetEntry().

void freeArgs | ( | MacroBuf | mb | ) | `[static]`

Free parsed arguments for parameterized macro.

Parameters:

  mb | macro expansion state

Definition at line 801 of file macro.c.

References _, MacroEntry_s::body, MacroBuf_s::depth, MacroContext_s::firstFree, MacroEntry_s::level, MacroBuf, MacroContext, MacroEntry, MacroContext_s::macroTable, MacroBuf_s::mc, MacroEntry_s::name, popMacro(), RPMERR_BADSPEC, rpmError, sortMacroTable(), and MacroEntry_s::used.

Referenced by expandMacro().

const char* grabArgs | ( | MacroBuf | mb,
|  | const MacroEntry | me,
|  | const char * | se,
|  | char | lastc
| ) | `[static]`

Parse arguments (to next new line) for parameterized macro.

Todo:
  Use popt rather than getopt to parse args.

Parameters:

  mb | macro expansion state
  me | macro entry slot
  se | arguments to parse
  lastc | stop parsing at lastc

Returns:
  address to continue parsing

Definition at line 852 of file macro.c.

References _, addMacro(), alloca(), MacroBuf_s::depth, expandU(), isblank, MacroBuf, MacroEntry, MacroBuf_s::mc, MacroEntry_s::name, MacroEntry_s::opts, RPMERR_BADSPEC, rpmError, and stpcpy().

Referenced by expandMacro().

int isCompressed | ( | const char * | file,
|  | rpmCompressedMagic * | compressed
| ) |

Return type of compression used in file.

Parameters:

  file | name of file

Return values:

  compressed | address of compression type

Returns:
  0 on success, 1 on I/O error

Definition at line 1668 of file macro.c.

References _, COMPRESSED_BZIP2, COMPRESSED_NOT, COMPRESSED_OTHER, COMPRESSED_ZIP, Fclose(), FD_t, Ferror(), Fopen(), Fread(), Fstrerror(), rpmCompressedMagic, RPMERR_BADSPEC, and rpmError.

Referenced by buildForTarget(), doFoo(), doPatch(), and doUntar().

const char* matchchar | ( | const char * | p,
|  | char | pl,
|  | char | pr
| ) | `[static]`

Return text between pl and matching pr characters.

Parameters:

  p | start of text
  pl | left char, i.e. '[', '(', '{', etc.
  pr | right char, i.e. ']', ')', '}', etc.

Returns:
  address of last char before pr (or NULL)

Definition at line 320 of file macro.c.

Referenced by doDefine(), and expandMacro().

void popMacro | ( | MacroEntry * | mep | ) | `[static]`

Pop macro definition from macro entry stack.

Parameters:

  mep | address of macro entry slot

Definition at line 779 of file macro.c.

References _free(), MacroEntry_s::body, MacroEntry, MacroEntry_s::name, MacroEntry_s::opts, and MacroEntry_s::prev.

Referenced by delMacro(), and freeArgs().

void printExpansion | ( | MacroBuf | mb,
|  | const char * | t,
|  | const char * | te
| ) | `[static]`

Post-print expanded macro expression.

Parameters:

  mb | macro expansion state
  t | current expansion string result
  te | end of string

Definition at line 390 of file macro.c.

References _, MacroBuf_s::depth, iseol, and MacroBuf.

Referenced by expandMacro().

void printMacro | ( | MacroBuf | mb,
|  | const char * | s,
|  | const char * | se
| ) | `[static]`

Pre-print macro expression to be expanded.

Parameters:

  mb | macro expansion state
  s | current expansion string
  se | end of string

Definition at line 346 of file macro.c.

References _, MacroBuf_s::depth, iseol, and MacroBuf.

Referenced by expandMacro().

void pushMacro | ( | MacroEntry * | mep,
|  | const char * | n,
|  | const char * | o,
|  | const char * | b,
|  | int | level
| ) | `[static]`

Push new macro definition onto macro entry stack.

Parameters:

  mep | address of macro entry slot
  n | macro name
  o | macro parameters (NULL if none)
  b | macro body (NULL becomes "")
  level | macro recursion level

Definition at line 750 of file macro.c.

References _free(), MacroEntry, MacroEntry_s::name, xmalloc(), and xstrdup().

Referenced by addMacro().

char* rdcl | ( | char * | buf,
|  | size_t | size,
|  | FD_t | fd,
|  | int | escapes
| ) | `[static]`

| fgets(3) analogue that reads \ continuations. Last newline always trimmed. Definition at line 277 of file macro.c. References fdGetFILE, and iseol. Referenced by rpmInitMacros().

char* rpmCleanPath | ( | char * | path | ) |

Canonicalize file path.

Parameters:

  path | path to canonicalize (in-place)

Returns:
  canonicalized path (malloc'ed)

Definition at line 1770 of file macro.c.

References begin.

Referenced by doLookup(), openDatabase(), rpmdbMoveDatabase(), rpmdbRemoveDatabase(), rpmGetPath(), and rpmQueryVerify().

int rpmDefineMacro | ( | MacroContext | mc,
|  | const char * | macro,
|  | int | level
| ) |

Define macro in context.

Parameters:

  mc | macro context (NULL uses global context).
  n | macro name, options, body
  level | macro recursion level (0 is entry API)

Returns:

Todo:
  Document.

Definition at line 1532 of file macro.c.

References alloca(), doDefine(), MacroBuf, MacroContext, and rpmGlobalMacroContext.

Referenced by main(), rpmdbRebuild(), and rpmInitMacros().

void rpmDumpMacroTable | ( | MacroContext | mc,
|  | FILE * | fp
| ) |

Print macros to file stream.

Parameters:

  mc | macro context (NULL uses global context).
  fp | file stream (NULL uses stderr).

Definition at line 200 of file macro.c.

References _, MacroEntry_s::body, MacroContext_s::firstFree, MacroEntry_s::level, MacroContext, MacroEntry, MacroContext_s::macroTable, MacroEntry_s::name, MacroEntry_s::opts, rpmGlobalMacroContext, and MacroEntry_s::used.

Referenced by expandMacro(), and rpmShowRC().

char* rpmExpand | ( | const char * | arg,
|  | ... |
| ) |

Return (malloc'ed) concatenated macro expansion(s).

Parameters:

  arg | macro(s) to expand (NULL terminates list)

Returns:
  macro expansion (malloc'ed)

Definition at line 1720 of file macro.c.

References expandMacros(), stpcpy(), and xstrdup().

Referenced by checkForValidArchitectures(), checkPassPhrase(), cpio_doio(), dbiTagsInit(), doPrimary(), doScript(), doSetupMacro(), fillOutMainPackage(), generateDepends(), i18nTag(), ignoreDep(), main(), makeGPGSignature(), makePGPSignature(), newRpmdb(), packageBinaries(), parseForRegexLang(), parseForRegexMultiLib(), parseSpec(), rdToken(), readLine(), rpmdbSetIteratorRE(), rpmExpandNumeric(), rpmGetPassPhrase(), rpmLookupSignatureType(), rpmReadConfigFiles(), rpmRollback(), runScript(), skipFiles(), urlFind(), verifyGPGSignature(), verifyPGPSignature(), and writeRPM().

int rpmExpandNumeric | ( | const char * | arg | ) |

Return macro expansion as a numeric value.

Boolean values ('Y' or 'y' returns 1, 'N' or 'n' returns 0) are permitted as well. An undefined macro returns 0.

Parameters:

  arg | macro to expand

Returns:
  numeric value

Definition at line 1743 of file macro.c.

References _free(), and rpmExpand().

Referenced by dbiOpen(), genCpioListAndHeader(), main(), newRpmdb(), openDatabase(), parseRCPOT(), parseSpec(), processPackageFiles(), rpmdbInit(), rpmdbOpen(), rpmdbRebuild(), rpmdbVerify(), rpmLeadVersion(), and skipFiles().

void rpmFreeMacros | ( | MacroContext | mc | ) |

Destroy macro context.

Parameters:

  mc | macro context (NULL uses global context).

Definition at line 1641 of file macro.c.

References _free(), MacroEntry_s::body, MacroContext_s::firstFree, MacroContext, MacroEntry, MacroContext_s::macroTable, MacroEntry_s::name, MacroEntry_s::opts, MacroEntry_s::prev, and rpmGlobalMacroContext.

Referenced by build(), and main().

const char* rpmGenPath | ( | const char * | urlroot,
|  | const char * | urlmdir,
|  | const char * | urlfile
| ) |

Merge 3 args into path, any or all of which may be a url.

The leading part of the first URL encountered is used for the result, other URL prefixes are discarded, permitting a primitive form of URL inheiritance.

Parameters:

  urlroot | root URL (often path to chroot, or NULL)
  urlmdir | directory URL (often a directory, or NULL)
  urlfile | file URL (often a file, or NULL)

Returns:
  expanded, merged, canonicalized path (malloc'ed)

Definition at line 1889 of file macro.c.

References _debug, _free(), alloca(), rpmGetPath(), URL_IS_DASH, and urlPath().

Referenced by buildForTarget(), db1close(), db1open(), db3close(), db3open(), db_init(), doScript(), doSetupMacro(), handlePreambleTag(), makeTempFile(), processBinaryFile(), processPackageFiles(), psmStage(), rpmInstall(), and rpmInstallSourcePackage().

const char* rpmGetPath | ( | const char * | path,
|  | ... |
| ) |

Return (malloc'ed) expanded, canonicalized, file path.

Parameters:

  path | macro(s) to expand (NULL terminates list)

Returns:
  canonicalized path (malloc'ed)

Definition at line 1858 of file macro.c.

References expandMacros(), rpmCleanPath(), stpcpy(), and xstrdup().

Referenced by addFileToTagAux(), addSource(), buildForTarget(), checkSpec(), db3close(), db3open(), doPatch(), doReadRC(), doRmSource(), doUntar(), newRpmdb(), packageBinaries(), packageSources(), parseFiles(), parseForSimple(), parseSpec(), processPackageFiles(), processSourceFiles(), psmStage(), readIcon(), rpmdbRebuild(), rpmDetectPGPVersion(), rpmErase(), rpmGenPath(), rpmGetFilesystemUsage(), rpmInstall(), setPathDefault(), verifyGPGSignature(), and verifyPGPSignature().

void rpmInitMacros | ( | MacroContext | mc,
|  | const char * | macrofiles
| ) |

Initialize global macro context from set of macrofile(s).

Parameters:

  mc | (unused)
  macrofiles | colon separated list of macro files (NULL does nothing)

Definition at line 1568 of file macro.c.

References _free(), Fclose(), FD_t, Ferror(), Fopen(), getenv(), MacroContext, macrofiles, max_macro_depth, rdcl(), RMIL_CMDLINE, RMIL_MACROFILES, rpmCLIMacroContext, rpmDefineMacro(), rpmGlobalMacroContext, rpmLoadMacros(), SKIPBLANK, and xstrdup().

Referenced by rpmReadRC().

void rpmLoadMacros | ( | MacroContext | mc,
|  | int | level
| ) |

Load macros from specific context into global context.

Parameters:

  mc | macro context (NULL does nothing).
  level | macro recursion level (0 is entry API)

Definition at line 1547 of file macro.c.

References addMacro(), MacroEntry_s::body, MacroContext_s::firstFree, MacroContext, MacroEntry, MacroContext_s::macroTable, MacroEntry_s::name, MacroEntry_s::opts, and rpmGlobalMacroContext.

Referenced by rpmInitMacros().

void sortMacroTable | ( | MacroContext | mc | ) | `[static]`

Sort entries in macro table.

Parameters:

  mc | macro context

Definition at line 179 of file macro.c.

References compareMacroName(), MacroContext_s::firstFree, MacroContext, and MacroContext_s::macroTable.

Referenced by addMacro(), delMacro(), and freeArgs().

## Variable Documentation

int _debug = 0`[static]`

| Definition at line 6 of file macro.c. Referenced by rpmGenPath().

int max_macro_depth = 16

| Definition at line 89 of file macro.c. Referenced by expandMacro(), and rpmInitMacros().

int print_expand_trace = 0

| Definition at line 100 of file macro.c. Referenced by expandMacro(), and expandMacros().

int print_macro_trace = 0

| Definition at line 98 of file macro.c. Referenced by expandMacro(), and expandMacros().

MacroContext rpmCLIMacroContext = &rpmCLIMacroContext_s

| Definition at line 66 of file macro.c.

struct MacroContext_s rpmCLIMacroContext_s`[static]`

| Definition at line 64 of file macro.c.

MacroContext rpmGlobalMacroContext = &rpmGlobalMacroContext_s

| Definition at line 61 of file macro.c.

struct MacroContext_s rpmGlobalMacroContext_s`[static]`

| Definition at line 59 of file macro.c.